searchData={"items":[{"type":"module","title":"Bex","doc":"`Bex` internals and helpers.","ref":"Bex.html"},{"type":"function","title":"Bex.io_diff/2","doc":"IO formatter for diffs","ref":"Bex.html#io_diff/2"},{"type":"function","title":"Bex.mfa/1","doc":"Retrieves `mfa` tuple from `Macro.Env`","ref":"Bex.html#mfa/1"},{"type":"function","title":"Examples - Bex.mfa/1","doc":"iex> Bex.mfa()\n    :world","ref":"Bex.html#mfa/1-examples"},{"type":"function","title":"Bex.telemetry_event_base/1","doc":"Builds a `telemetry` event base name from `Macro.Env`","ref":"Bex.html#telemetry_event_base/1"},{"type":"function","title":"Bex.telemetry_measurements_base/1","doc":"Standard `:telemetry.span/3`-like measurements","ref":"Bex.html#telemetry_measurements_base/1"},{"type":"task","title":"mix bex.generate","doc":"Mix task to generate the `Bex` wrapping behaviour scaffold.\n\nBy running `mix bex.generate --module ModuleToConvert` or\n`mix bex.generate --function Module.function_to_convert/arity`\ntwo modules are to be generated:\n\n- behaviour module for the functions(s)\n- default implementation module, wrapping the original function(s)","ref":"Mix.Tasks.Bex.Generate.html"},{"type":"task","title":"Allowed arguments - mix bex.generate","doc":"- **`--module: :string`** _or_ **`--function: :string`** __[mandatory]__ the name of the module\n  or the function to convert to behaviour implementation\n- **`--dir: :string`** __[optional, default: `lib/bex`]__ the target directory for generated\n  modules\n- **`--patch`** __[optional, default: `true`]__ if `false`, no attempt to patch found occurences\n  of calls to the behavioured function(s) would be made\n- **`--backup`** __[optional, default: `false`]__ if `true`, the file will be backed up with `.bex`\n  extension before patching\n- **`--test`** __[optional, default: `true`]__ if `false`, tests for patched calls will not be generated\n  (it has no effect with `--no-patch`)","ref":"Mix.Tasks.Bex.Generate.html#module-allowed-arguments"},{"type":"task","title":"Example - mix bex.generate","doc":"```sh\nmix bex.generate --function Process.send_after/4 --no-patch\n```","ref":"Mix.Tasks.Bex.Generate.html#module-example"},{"type":"extras","title":"Bex","doc":"# Bex\n\n**The set of mix tasks to help dealing with behaviours and mocks**","ref":"readme.html"},{"type":"extras","title":"Installation - Bex","doc":"```elixir\ndef deps do\n  [\n    {:bex, \"~> 0.1\", runtime: false}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Bex","doc":"```elixir\nmix bex.generate --function Process.send_after/4\n```\n\nThe above will generate the behaviour module `Bex.Behaviours.Process` and its default\nimplementation which should be called instead of a direct call to the original function.\n\nAlso `Mox` scaffold and `telemetry` call will be generated.\n\n## [Documentation](https://hexdocs.pm/bex)","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}